classdef dipoleAndMeasureOfStudySpec < pr.dipoleAndMeasureOfStudy
    % holds ERPs from one or several conditions in a linearized way.
    % the first dimension is the linearized version of the Spectrum for concatenated subset of
    % consitions.
    % the second dimension of value is dipoles.
    properties
        frequency = [];
    end % properties
     properties (Constant = true)
        numberOfMeasureDimensions = 1; % number of dimensions in measure
    end;% properties
        methods (Access = 'protected')
        function plotMeasureAsArrayInCell(obj, measureAsArrayInCell, title, varargin)            
            std_plotcurve(obj.frequency, measureAsArrayInCell, 'titles', title, 'datatype','spec', varargin{:});
        end;
    end;
    methods
        function obj = dipoleAndMeasureOfStudySpec(STUDY, ALLEEG, varargin) % constructor
            % conditionId is an optional input that specifies which conditions should be included.
            % by default all conditions are included.
            
            superClassArgs = {};
            
            if nargin>1
                superClassArgs{1} = STUDY;
                superClassArgs{2} = ALLEEG;
            end;
            
            if nargin>2
                for i=1:length(varargin) % pass additional parameters in varargin to parent dipoleAndMeasureOfStudy class
                    superClassArgs{2+i} = varargin{i};
                end;
            end;  
            
            obj = obj@pr.dipoleAndMeasureOfStudy(superClassArgs{:}); % call the super class constructor
            
            if nargin > 0
                [STUDY clustinfo] = std_readdata(STUDY,ALLEEG,'clusters',STUDY.etc.preclust.clustlevel,'infotype','spec');
                clustinfo = STUDY.cluster(STUDY.etc.preclust.clustlevel);
                
                % combine conditions in each group, then combine groups together
                for group=1:obj.numberOfGroups
                    combinedConditions{group} = cat(1,clustinfo.specdata{obj.conditionId,group});
                end;
                
                icCombinedSpec = cat(2, combinedConditions{:});
                obj.linearizedMeasure = icCombinedSpec(:,obj.icIndexForEachDipole);
                obj.frequency = STUDY.cluster(1).specfreqs;
                
                obj = createSubsetInRelationToBrain(obj, obj.relationshipToBrainVolume);                
            end;
        end;        
    end;
end