function locationsInMniCoordinate = spherical_coordinate_to_mni(location)
% locationsInMniCoordinate = spherical_coordinate_to_mni(location)
% location is an N x 3 array containing N dipole positions or moments.

% this is the output of sp2spm() function of dipfit plugin.
transferMatrix  =...
[    0.0101   -0.9400         0    0.5588
    1.1889    0.0080    0.0530  -18.0041
   -0.0005         0    1.1268    1.8045
         0         0         0    1.0000];

locationsInMniCoordinate = zeros(size(location));
for i=1:size(location,1)
    singleLocationInMniCoordinate = transferMatrix * [location(i,:) 1]';
    locationsInMniCoordinate(i,:) = singleLocationInMniCoordinate(1:3);
end;